{

(c) GNU General Public License
(c) 2000 by raVen

abp - automatic base packer

supported compilers: borland pascal 7.0, virtual pascal 2.0b+

all lacking sources on http://raven66.newmail.ru/sources.html

}
{$IfDef VirtualPascal}
{$B+,D+,H-,I-,J+,P-,Q-,R-,S-,T-,V+,W-,X+,Z-}
{&AlignCode+,AlignData+,AlignRec-,Asm-,Delphi+,Frame+,G3+,LocInfo+,Open32+}
{&Optimise+,OrgName-,SmartLink+,Speed+,Use32+,ZD+}
{$M 262144}
{$EndIf}

{$IfDef Ver70}
{$A+,B+,D+,E+,F+,G+,I-,L+,N+,O+,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 65520,0,655360}
{$EndIf}

{/$Define Debug}
Uses
 OpCrt, OpString, Objects, rObjects, Dos, rOpen, Raf, rConfig, Strings, rAbs,
 Memory, rMacroz
{$IfDef VirtualPascal}
, VPUtils;
{$EndIf}
{$IfDef Ver70}
;
{$EndIf}

type
 tAbp = object(tObject)
  PackBases: Boolean;
  leak: Longint;
  MaxMessages: Longint;
  Bases: pLines;
  ArcExtension,ArcAdd: pString;
  constructor Init;
  destructor Done; virtual;
  procedure Run;
  procedure Abort(Reason: String);
 end;

constructor tAbp.Init;
 var
  s: String;
  ini: pTextConfig;
  x: Integer;
 begin
{$IfDef Debug}
 {$IfDef VirtualPascal}
  leak:=MemUsed;
 {$EndIf}
 {$IfDef Ver70}
  Leak:=MemAvail;
 {$EndIf}
{$EndIf}

  WriteLn(#13#10'automatic base packer v0.1');
  WriteLn('(c) 2000 by raVen'#13#10);
  if (ParamCount<>1) then
   begin
    WriteLn('usage: abp.exe [/p]|[/c]');
    WriteLn('       /p - pack base');
    WriteLn('       /c - only copy base');
    Abort('');
   end;
  s:=UpStr(ParamStr(1));
  if (s='/P') then PackBases:=True
  else if (s='/C') then PackBases:=False
  else Abort('unknown command line switch');

  s:=AddBackSlash(JustPathName(ParamStr(0)))+'abp.ctl';
  if not Exist(s) then Abort(qBracket1+s+qBracket2+' is not found!');

  New(Ini,Init);
  New(Bases,Init(16,16));
  with (Ini^) do
   begin
    AddWord('MaxMessages');
    AddWord('Base');
    AddWord('Arc.Extension');
    AddWord('Arc.Add');
    if Load(s)<>0 then
     begin
      DisposeObj(Ini);
      Abort('cannot load '+qBracket1+s+qBracket2);
     end;
    MaxMessages:=CToN(GetValue(1,1));
    for x:=1 to GetValueCount(2) do Bases^.Insert(NewStr(GetValue(2,x)));
    ArcExtension:=NewStr(GetValue(3,1));
    ArcAdd:=NewStr(GetValue(4,1));
    if GetBadLineCount>0 then
     begin
      for x:=1 to GetBadLineCount do WriteLn('wrong line #'+qBracket1,GetBadLine(x),qBracket2+' in '+qBracket1+s+qBracket2);
      WriteLn('pause (3 seconds)...');
      Delay(3000);
     end;
   end;
  DisposeObj(Ini);
 end;

destructor tAbp.Done;
 begin
  DisposeObj(Bases);
  ReallocStr(ArcExtension,'');
  ReallocStr(ArcAdd,'');

{$IfDef Debug}
{$IfDef VirtualPascal}
  WriteLn('memory leak is ',MemUsed-leak,' bytes.');
{$EndIf}
{$IfDef Ver70}
  WriteLn('memory leak is ',leak-MemAvail,' bytes.');
{$EndIf}
{$EndIf}
 end;

procedure tAbp.Run;
 var
  s1,s2: String;
  x,y: Integer;
  Base: pAbsBase;
  m: pMacros;
 begin
  with Bases^ do if Count<=0 then Abort('nothing to archiving...')
  else for x:=0 to Count-1 do
   begin
    s1:=GetPS(At(x));
    s2:=AddBackSlash(ExtractWord(2,s1,SpaceChars));
    s1:=ExtractWord(1,s1,SpaceChars);
    Write('processing base '+qBracket1+s1+qBracket2+Point+Point+Point+Space);
    Base:=OpenOrCreateBase(s1);
    if Base=nil then WriteLn('cannot open!');
    if (Base^.Count<=MaxMessages) then
     begin
      WriteLn('only ',Base^.Count,' messages. let it live.');
      DisposeObj(Base);
      Continue;
     end;
    Write(Base^.Count,' messages. ');
    DisposeObj(Base);
    y:=0;
    while (true) do
     begin
      if (not Exist(ForceExtension(s2+HexL(y),GetPS(ArcExtension)))) and (not DExist(s2+HexL(y))) then Break;
      Inc(y);
     end;
    CopyBase(s1,s2+HexL(y));
    Base:=CreateBase(s1);
    DisposeObj(Base);
    if PackBases then
     begin
      s1:=' /C '+GetPS(ArcAdd);
      New(m,Init);
      with (m^) do
       begin
        AddStringMacro('@ArcName',s2+HexL(y),False);
        AddStringMacro('@FileName',s2+HexL(y),False);
        ProcessString(s1);
       end;
      DisposeObj(m);
    {$IfDef MsDos}
     {$IfNDef DPMI}
      SetMemTop(HeapPtr);
     {$EndIf}
      SwapVectors;
    {$EndIf}
      Exec(GetEnv(StrPas('COMSPEC')),s1);
    {$IfDef MsDos}
      SwapVectors;
     {$IfNDef DPMI}
      SetMemTop(HeapEnd);
     {$EndIf}
    {$EndIf}
     end;
    if (DosExitCode=0) and (PackBases) then
     begin
      WriteLn('packed to '+qBracket1+ForceExtension(s2+HexL(y),GetPS(ArcExtension))+qBracket2);
      DelDir(s2+HexL(y),false);
     end
    else WriteLn('copied to '+qBracket1+s2+HexL(y)+qBracket2);
   end;
 end;

procedure tAbp.Abort;
 begin
  WriteLn(Reason);
  WriteLn('exiting...');
  Done;
  Halt(Random(255));
 end;

var
 abp: tAbp;
begin
 abp.Init;
 abp.Run;
 abp.Done;
end.
